
--freemarker template

<#assign systeminfo_id=9 />
<#assign sachgebiete_id=0 />


<#assign projects= [
{"uniquename":"kern_user",
"name":"Kernmodul Benutzerverwaltung",
"issue_link":"https://git.campussource.de/git/SuperX/qa/issues/"
}
  ] />


<#assign  mask_executions = [
    {
  "project":"kern_user",
  "uniquename":"kern_adminuser_exists_mask",
  "name":"Benutzeraccounts mit Administrationsrechten existieren", 
  "userinfo_id":"1",
  "maskeninfo_id":"71050",
  "description":"",
  "issue_id":"1"
  }
    
 ] />
<#assign  mask_execution_fields = [
    {
  "mask_execution_uniquename":"kern_adminuser_exists_mask",
  "felderinfo_id":"71053", 
  "field_value":"Admin"
  }
    
 ] /> 
 <#assign  mask_execution_assertions = [
  
   {
  "mask_execution_uniquename":"kern_adminuser_exists_mask",
  "rownr":"1",
   "colnr": "2",
  "result_value_min": "1",
  "result_value_max": "1000",
  "assertion_caption":"Anzahl Admin-Accounts"
  }  
 ] />


--ab hier ist der Code immer gleich:


<#foreach project in projects>

insert into qa_project(
uniquename,
       name,
       systeminfo_id,
       sachgebiete_id,
       active,
       issue_link,
       created_at,
       created_from
)
select 
'${project.uniquename}',
'${project.name}',
${systeminfo_id},
${sachgebiete_id},
1 as active,
'${project.issue_link}',
today(),
1
from xdummy
where 0=(select count(*) from qa_project P
where P.uniquename='${project.uniquename}'
and P.systeminfo_id=${systeminfo_id});

<#foreach mask_execution in mask_executions>
<#if mask_execution.project=project.uniquename>
insert into qa_mask_execution(
uniquename,
name,
systeminfo_id,
userinfo_id,
maskeninfo_id,
--description,
is_active)
 select '${mask_execution.uniquename}',
'${mask_execution.name}',
${systeminfo_id},
${mask_execution.userinfo_id},
${mask_execution.maskeninfo_id},
1 as active
FROM qa_project
where uniquename= '${project.uniquename}'
and systeminfo_id=${systeminfo_id}
and 0=(select count(*) from qa_mask_execution T
where T.uniquename='${mask_execution.uniquename}'
and T.systeminfo_id=${systeminfo_id})
;

insert into qa_mask_execution2project(  mask_execution_id,
project_id,
issue_id)
       select T.tid,
       P.tid,
'${mask_execution.issue_id}'
       FROM qa_mask_execution T,qa_project P
       where T.uniquename='${mask_execution.uniquename}'
       and T.systeminfo_id=${systeminfo_id}
       and P.uniquename= '${project.uniquename}'
       and P.systeminfo_id=${systeminfo_id}
       and 0=(select count(*) from qa_mask_execution2project TP,
       qa_mask_execution T,qa_project P
where T.uniquename='${mask_execution.uniquename}'
and T.systeminfo_id=${systeminfo_id} 
 and P.uniquename= '${project.uniquename}'
       and P.systeminfo_id=${systeminfo_id}
       and TP.project_id=P.tid
       and TP.mask_execution_id=T.tid)
       ;

<#foreach field in mask_execution_fields>
<#if field.mask_execution_uniquename=mask_execution.uniquename>
insert into qa_mask_field_sel(
mask_execution_id,
       felderinfo_id,
       field_value,
       is_active
       )
select tid,
${field.felderinfo_id},
'${field.field_value}',
1 as is_active
from qa_mask_execution T
where T.uniquename='${mask_execution.uniquename}'
and T.systeminfo_id=${systeminfo_id}
and 0=(select count(*) from qa_mask_field_sel A
where A.mask_execution_id=T.tid
and A.felderinfo_id=${field.felderinfo_id}
);
 

</#if> --von field
</#foreach>
       
       
<#foreach assertion in mask_execution_assertions>
<#if assertion.mask_execution_uniquename=mask_execution.uniquename>
insert into qa_mask_execution_assert(
 mask_execution_id,
       rownr,
       colnr,
       result_value_min,
       result_value_max,
       is_active,
       caption
       )
select tid,
${assertion.rownr},
${assertion.colnr},
${assertion.result_value_min},
${assertion.result_value_max},
1 as is_active,
'${assertion.assertion_caption}'
from qa_mask_execution T
where T.uniquename='${mask_execution.uniquename}'
and T.systeminfo_id=${systeminfo_id}
and 0=(select count(*) from qa_mask_execution_assert A
where A.mask_execution_id=T.tid
and A.rownr=${assertion.rownr}
and A.colnr=${assertion.colnr});
 

</#if> --von assertion
</#foreach>



</#if> --von mask_execution
</#foreach>
</#foreach>

